#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2013/12/24 00:16:12 +0900>
#
# vC[L𓮂Ă݂Tv1
# ړA␳A̔

require 'dxruby'
require 'tmx'
require_relative 'dxrbtmx'
require_relative 'bgatari'

# 摜ǂݍ
pimg = Image.loadTiles("player.png", 640/80, 640/80)
bgimg = Image.loadTiles("bg_attari.png", 256/16, 256/16)

# tmxǂݍ
scrw, scrh = Window.width, Window.height
tmx = DxrbTmx.new("./bg_atari_test.tmx", scrw, scrh)

# BgC[}bvf[^擾
atari_layer = tmx.get_layer("bg_atari")
bg_layer0 = tmx.get_layer("layer0")
bg_layer1 = tmx.get_layer("layer1")
bg_layer2 = tmx.get_layer("layer2")
bg_layer3 = tmx.get_layer("layer3")

bgtw, bgth = tmx.screenwidth, tmx.screenheight

# BGA^e[u쐬
bgatari = BgAtari.new(bgimg, atari_layer, scrw, scrh, 0, 22, 30)

# J[\`p\bh
def draw_cursor(x, y, col)
  w = 2
  Window.drawLine(x - w, y, x + w, y, col)
  Window.drawLine(x, y - w, x, y + (w + 1), col)
end

bx, by = 0, 0
px, py = scrw / 2, scrh / 2
dx, dy = 0, 0
gravity = 0.45
pimgnum = 16

# C[v
Window.loop do
  break if Input.keyPush?(K_ESCAPE)

  # vC[ړ

  # EL[ŉړ
  # xxɁAL[͂ɉĉxZ
  dx += Input.x * 0.2

  # ̍ő呬x𒴂Ȃ悤ɂ
  spdmax = 6.0
  dx = spdmax if dx >= spdmax
  dx = -spdmax if dx < -spdmax

  # EL[ĂȂ΁Ax炵Ă
  dx *= 0.95 if Input.x == 0

  # xZ
  px += dx
  py += dy

  # A^ŕ␳
  if pimgnum == 16
    # 
    yadd = 0
  else
    # ̏ɋ
    # 肿Ɖ̍WŃA^
    yadd = 16
  end
  nx, ny = bgatari.adjust_bg_hit(px, py + yadd, BgAtari::ADJUST_UP)

  if nx == nil
    # ɏ
    dy += gravity # d͉xAxɉZ
    pimgnum = 16 # |[YɕύX
  else
    # ɏ
    py = ny
    dy = 0 # yx0ɂ
    pimgnum = 0 # ̏ɋ|[YɕύX
  end

  # vC[ړ܂

  # vC[̈ʒuABGXN[W
  bx += ((px.to_i - (scrw / 2) - bx) * 0.2).to_i
  by += ((py.to_i - (scrh / 2) - by) * 0.2).to_i

  # BG`
  Window.drawTile(0, 0, bg_layer3, bgimg, bx / 8, by / 8, bgtw, bgth)
  Window.drawTile(0, 0, bg_layer2, bgimg, bx / 4, by / 4, bgtw, bgth)
  Window.drawTile(0, 0, bg_layer1, bgimg, bx / 2, by / 2, bgtw, bgth)
  Window.drawTile(0, 0, bg_layer0, bgimg, bx, by, bgtw, bgth)

  # vC[`
  x = px - bx
  y = py - by
  img = pimg[pimgnum]
  Window.draw(x - 40, y - 68, img)

  # vC[WɃJ[\`
  draw_cursor(x, y, C_RED)
end
