#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2013/12/25 20:03:37 +0900>
#
# vC[L𓮂Ă݂Tv3
#
# ړAA␳AǕ␳A
# WvAV␳B

require 'dxruby'
require 'tmx'
require_relative 'dxrbtmx'
require_relative 'bgatari'

font = Font.new(12)

# 摜ǂݍ
pimg = Image.loadTiles("player_512x256_64x64.png", 512 / 64, 256 / 64)
bgimg = Image.loadTiles("bg_attari.png", 256 / 16, 256 / 16)

# tmxǂݍ
scrw, scrh = Window.width, Window.height
tmx = DxrbTmx.new("./bg_atari_test.tmx", scrw, scrh)

# BgC[}bvf[^擾
atari_layer = tmx.get_layer("bg_atari")
bg_layer0 = tmx.get_layer("layer0")
bg_layer1 = tmx.get_layer("layer1")
bg_layer2 = tmx.get_layer("layer2")
bg_layer3 = tmx.get_layer("layer3")

bgtw, bgth = tmx.screenwidth, tmx.screenheight

# BGA^e[u쐬
bgatari = BgAtari.new(bgimg, atari_layer, scrw, scrh, 0, 22, 30)

# 󒆏
float_floor = 21

# J[\`p\bh
def draw_cursor(x, y, col)
  w = 2
  Window.drawLine(x - w, y, x + w, y, col)
  Window.drawLine(x, y - w, x, y + (w + 1), col)
end

# vC[̃Ajp^[`
ppat = { "walk" => 0, "jump" => 16}
pimgnum = ppat["jump"]

bx, by = 0, 0
px, py = scrw / 2, scrh / 2
dx, dy = 0, 0
gravity = 0.45
bgatari_disp = false

wall_dist = 16 # ǃA^`FbN鋗
ceiling_dist = 54 # VA^`FbN鋗

# XN[W͈̔
scrl_spc = 16
bx_min = scrl_spc
by_min = scrl_spc
bx_max = tmx.map_width - Window.width - scrl_spc
by_max = tmx.map_height - Window.height - scrl_spc

# C[v
Window.loop do
  break if Input.keyPush?(K_ESCAPE)

  # BL[BGA^\Ɛؑ
  bgatari_disp = !bgatari_disp if Input.keyPush?(K_B)

  # vC[ړ

  # EL[ŉړ
  # xxɁAL[͂ɉĉxZ
  dx += Input.x * 0.2

  # ̍ő呬x𒴂Ȃ悤ɂ
  spdmax = 6.0
  dx = spdmax if dx >= spdmax
  dx = -spdmax if dx < -spdmax

  # EL[ĂȂ΁Ax炵Ă
  dx *= 0.95 if Input.x == 0

  # Wv{^(ZL[/Q[pbh̃{^0)ĂAWv
  # ĉ܂܂Ƌ󒆂łWvłႤǁAȂ񂾂ʔcƂ

  # if Input.padPush?(P_BUTTON0)
  if Input.padDown?(P_BUTTON0)
    # dy = -16 # yxɐݒ
    dy = -10 # yxɐݒ
    pimgnum = ppat["jump"] # Wv|[Yɂ
  end

  # xZ
  px += dx
  py += dy

  # VA^ŕ␳
  if dy < 0
    # yx̎VA^
    xadd, yadd = 0, -ceiling_dist
    nx, ny = bgatari.adjust_bg_hit(px + xadd, py + yadd, BgAtari::ADJUST_DOWN)
    if nx and bgatari.bg_code != float_floor
      # V䑤ɁA󒆏ȊOBGA^
      py = ny - yadd # W␳
      dy = 0 # yx0ɂ
    end
  end

  # ǃA^ŕ␳

  # EBGA^邩`FbN
  # xadd, yadd = 32, -32
  xadd, yadd = wall_dist, -32
  nx, ny = bgatari.adjust_bg_hit(px + xadd, py + yadd, BgAtari::ADJUST_LEFT)
  if nx and bgatari.bg_code != float_floor
    # EɁA󒆏ȊÕA^
    px = nx - xadd # W␳
    dx = 0 # xx0
  end

  # BGA^邩`FbN
  # xadd, yadd = -32, -32
  xadd, yadd = -wall_dist, -32
  nx, ny = bgatari.adjust_bg_hit(px + xadd, py + yadd, BgAtari::ADJUST_RIGHT)
  if nx and bgatari.bg_code != float_floor
    # ɁA󒆏ȊÕA^
    px = nx - xadd # W␳
    dx = 0 # xx0
  end

  # A^ŕ␳
  if dy < 0
    # ɔł
    dy += gravity # d͉xAxɉZ
  else
    # ɔłÁȀɋ

    # ̏ɋ鎞A肿Ɖ̍WŃA^
    yadd = (pimgnum == ppat["jump"])? 0 : 12
    nx, ny = bgatari.adjust_bg_hit(px, py + yadd, BgAtari::ADJUST_UP)

    if nx == nil
      # ɏ
      dy += gravity # d͉xAxɉZ
      pimgnum = ppat["jump"] # |[YɕύX
    else
      # ɏ
      py = ny # W␳
      dy = 0 # yx0ɂ
      pimgnum = ppat["walk"] # ̏ɋ|[YɕύX
    end
  end

  # vC[ړ܂

  # vC[̈ʒuABGXN[W
  bx += ((px.to_i - (scrw / 2) - bx) * 0.25).to_i
  by += ((py.to_i - (scrh / 2) - by) * 0.25).to_i
  if true
    # XN[͈͂𐧌ꍇ
    bx = bx_min if bx < bx_min
    by = by_min if by < by_min
    bx = bx_max if bx > bx_max
    by = by_max if by > by_max
  end

  # BG`
  if bgatari_disp
    Window.drawTile(0, 0, atari_layer, bgimg, bx, by, bgtw, bgth)
  else
    Window.drawTile(0, 0, bg_layer3, bgimg, bx / 8, by / 8, bgtw, bgth)
    Window.drawTile(0, 0, bg_layer2, bgimg, bx / 4, by / 4, bgtw, bgth)
    Window.drawTile(0, 0, bg_layer1, bgimg, bx / 2, by / 2, bgtw, bgth)
    Window.drawTile(0, 0, bg_layer0, bgimg, bx, by, bgtw, bgth)
  end

  # vC[`
  x = px - bx
  y = py - by
  Window.draw(x - 32, y - 57, pimg[pimgnum])

  # vC[WɃJ[\`
  draw_cursor(x, y, C_RED)
  draw_cursor(x + wall_dist, y - 32, C_RED)
  draw_cursor(x - wall_dist, y - 32, C_RED)
  draw_cursor(x, y - ceiling_dist, C_RED)

  Window.drawFont(8, 8, "Move:   / Jump: Z / BG atari: B", font)
end
